<?php

class FlyerTech_Transactionale_Model_Observer extends Varien_Event_Observer
{

    public function log($value)
    {
        Mage::helper('transactionale')->log($value);
    }

    public function checkoutOptinSaveOrderAfter(Varien_Event_Observer $observer)
    {
        $opt_in = Mage::app()->getRequest()->getParam('opt_in', '');

        try {
            if (!empty($opt_in)) {
                $customer_id = $observer->getEvent()->getOrder()
                    ->getCustomer()
                    ->getId();
                if ($customer_id) {
                    Mage::getModel('customer/customer')
                        ->load($customer_id)
                        ->setOpt_in($opt_in)
                        ->save();
                }
                $observer->getEvent()->getOrder()->setCustomerOptIn(true);
            }

        } catch (Exception $e) {
            $this->log($e);
        }
    }

    public function checkoutOptinSaveOrder(Varien_Event_Observer $observer)
    {
        try {
            if (!empty($opt_in)) {
                $customer_id = $observer->getOrder()
                    ->getCustomer()
                    ->getId();
                if ($customer_id) {
                    Mage::getModel('customer/customer')
                        ->load($customer_id)
                        ->setOpt_in($opt_in)
                        ->save();
                }
                $observer->getEvent()->getOrder()->setCustomerOptIn(true);
            }

        } catch (Exception $e) {
            $this->log($e);
        }
    }

    public function productListSingleton(Varien_Event_Observer $observer)
    {
        try {

            $collection = $observer->getCollection();
            Mage::register('current_category_products', $collection, true);

        } catch (Exception $e) {
            $this->log($e);
        }
    }

    public function checkoutOnepageControllerSuccessAction(Varien_Event_Observer $observer)
    {
        if (Mage::helper('transactionale')->isPublisher() && !Mage::helper('transactionale')->isTrackTransactionClientIntegration()) {
            $order_ids = $observer->getData('order_ids');
            foreach ($order_ids as $order_id) {
                try {
                    Mage::helper('transactionale')->trackOrder($order_id);

                } catch (Exception $e) {
                    $this->log($e);
                }

            }
        }
    }

    public function modelSaveBefore(Varien_Event_Observer $observer)
    {
        $model = $observer->getObject();
        if (!$model instanceof Mage_Customer_Model_Customer) {
            return;
        }
        $request = Mage::app()->getRequest();
        $module = $request->getControllerModule();
        $module_controller = $request->getControllerName();
        $module_controller_action = $request->getActionName();
        $fullActionName = $module . "_" . $module_controller . "_" . $module_controller_action;
        if ("Mage_Newsletter_manage_save" != $fullActionName) {
            return;
        }

        $inputs = $request->getParams();
        $optin = isset($inputs['opt_in']) ? $inputs['opt_in'] : 0;
        $model->setOpt_in($optin);

        if ($optin) {
            Mage::getSingleton('core/session')->addSuccess(Mage::helper('transactionale')->__('You will receive offers from our partners with your next order'));
        } else {
            Mage::getSingleton('core/session')->addSuccess(Mage::helper('transactionale')->__('You will not receive offers from our partners'));
        }

    }
}